﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Media3D;

namespace Matrix3DProjectionDemo
{
    public partial class Matrix3DDisplay : UserControl
    {
        const string format = "F4";

        public static readonly DependencyProperty Matrix3DProperty =
            DependencyProperty.Register("Matrix3D",
                typeof(Matrix3D),
                typeof(Matrix3DDisplay),
                new PropertyMetadata(OnMatrix3DChanged));

        public Matrix3DDisplay()
        {
            InitializeComponent();
        }

        public Matrix3D Matrix3D
        {
            set { SetValue(Matrix3DProperty, value); }
            get { return (Matrix3D)GetValue(Matrix3DProperty); }
        }

        static void OnMatrix3DChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            Matrix3DDisplay ctrl = obj as Matrix3DDisplay;
            Matrix3D matx = ctrl.Matrix3D;

            ctrl.textM11.Text = matx.M11.ToString(format);
            ctrl.textM12.Text = matx.M12.ToString(format);
            ctrl.textM13.Text = matx.M13.ToString(format);
            ctrl.textM14.Text = matx.M14.ToString(format);
            ctrl.textM21.Text = matx.M21.ToString(format);
            ctrl.textM22.Text = matx.M22.ToString(format);
            ctrl.textM23.Text = matx.M23.ToString(format);
            ctrl.textM24.Text = matx.M24.ToString(format);
            ctrl.textM31.Text = matx.M31.ToString(format);
            ctrl.textM32.Text = matx.M32.ToString(format);
            ctrl.textM33.Text = matx.M33.ToString(format);
            ctrl.textM34.Text = matx.M34.ToString(format);
            ctrl.textM41.Text = matx.OffsetX.ToString(format);
            ctrl.textM42.Text = matx.OffsetY.ToString(format);
            ctrl.textM43.Text = matx.OffsetZ.ToString(format);
            ctrl.textM44.Text = matx.M44.ToString(format);
        }
    }
}
